疯狂java


您现在的位置: 疯狂软件 >> 新闻资讯 >> 正文

再探Java基础throw与throws


 

 
浅谈Java异常
以前虽然知道一些异常的处理,也用过一些,但是对throw和throws区别还是有不太清楚。今天用实例测试一下
异常处理机制
异常处理是对可能出现的异常进行处理,以防止程序遇到异常时被卡死,处于一直等待,或死循环
异常有两个过程,一个是抛出异常;一个是捕捉异常
抛出异常
抛出异常有三种形式,一是throw,一个throws,还有一种系统自动抛异常。下面它们之间的异同
系统自动抛异常
当程序语句出现一些逻辑错误、主义错误或类型转换错误时,系统会自动抛出异常。如:
1 public static void main(String[] args) {  
2         int a = 5, b =0;  
3         System.out.println(5/b);  
4         //function();  
5 } 
  系统会自动抛出ArithmeticException异常:
  Exception in thread "main" java.lang.ArithmeticException: / by zero
 
  at test.ExceptionTest.main(ExceptionTest.java:62)
 
   再如:
  系统会自动抛出NumberFormatException异常:
  Exception in thread "main" java.lang.NumberFormatException: For input string: "abc"
 
  at sun.misc.FloatingDecimal.readJavaFormatString(FloatingDecimal.java:1224)
 
  at java.lang.Double.parseDouble(Double.java:510)
 
  at test.ExceptionTest.main(ExceptionTest.java:62)
 
throw
throw是语句抛出一个异常
语法:throw(异常对象);
如:throw e;
一般会用于程序出现某种逻辑时程序员主动抛出某种特定类型的异常。如:
复制代码
1 public static void main(String[] args) {  
2         String s = "abc";  
3         if(s.equals("abc")) {  
4             throw new NumberFormatException();  
5         } else {  
6             System.out.println(s);  
7         }  
8         //function();  
9 }
复制代码
  会抛出异常:
 
  Exception in thread "main" java.lang.NumberFormatException
 
  at test.ExceptionTest.main(ExceptionTest.java:67)
 
throws
throws是方法可能抛出异常的声明。(用在声明方法时,表示该方法可能要抛出异常,允许声明抛出多个异常,用逗号隔开)
语法:[(修饰符)](返回值类型)(方法名)([参数列表])[throws(异常类)]{......}
如:public void function() throws Exception{......}
当某个方法可能会抛出某种异常时用于throws 声明可能抛出的异常,然后交给上层调用它的方法程序处理。如:
复制代码
 1     public static void function() throws NumberFormatException{  
 2             String s = "abc";  
 3             System.out.println(Double.parseDouble(s));  
 4         }  
 5           
 6         public static void main(String[] args) {  
 7             try {  
 8                 function();  
 9             } catch (NumberFormatException e) {  
10                 System.err.println("非数据类型不能转换。");  
11                 //e.printStackTrace();  
12             }  
13     }   
复制代码
  处理结果如下:
 
  非数据类型不能转换。
 
throw与throws的比较
1、throws出现在方法函数头;而throw出现在函数体
2、throws表示出现异常的一种可能性,并不一定会发生这些异常;throw则是抛出了异常,执行throw则一定抛出了某种异常对象
3、两者都是消极处理异常的方式(这里的消极并不是说这种方式不好),只是抛出或者可能抛出异常,但是不会由函数去处理异常,真正的处理异常由函数的上层调用处理
好的编程习惯:
1.在写程序时,对可能会出现异常的部分通常要用try{...}catch{...}去捕捉它并对它进行处理
2.用try{...}catch{...}捕捉了异常之后一定要对在catch{...}中对其进行处理,那怕是最简单的一句输出语句,或栈输入e.printStackTrace()
3.如果是捕捉IO输入输出流中的异常,一定要在try{...}catch{...}后加finally{...}把输入输出流关闭
4.如果在函数体内用throw抛出了某种异常,最好要在函数名中加throws抛异常声明,然后交给调用它的上层函数进行处理
捕捉异常
先讲捕捉异常
复制代码
1 try{  
2  ……  
3 }catch(Exception e){  
4  ……  
5 }finally{  
6  ……  
7 } 
复制代码
try{……}中放置可能会发生异常的的语句块,如可能出现异常的函数,也可以是一般的程序语句;catch(){……}用于抓住异常,(Exception e)中Exception是异常的类型,必须是Exception(Exception是所有异常类的父类)的子类。{}定义当出现异常时的处理方法。finally{……}表示不管异常是否发生,都得进行finally{}中的处理
在捕捉异常的try{...}语句块中,如果出现了异常,则该语句(出现异常的语句)后的程序语句都不执行,而是跳到catch{...}语句块中执行异常的处理。如:
复制代码
 1 public static void function1() throws NumberFormatException{  
 2         System.out.println(Double.parseDouble("abc"));  
 3         System.out.println("第二条语句。");  
 4           
 5     }  
 6   
 7     public static void main(String[] args) {  
 8         try {  
 9             function1();  
10         } catch (Exception e) {  
11             System.err.println(e.getMessage());  
12             //e.printStackTrace();  
13         }  
14 } 
复制代码
结果如下,只输出了一条错误提示语:
For input string: "abc"
System.out.println("第二条语句。");未执行。
如果一个函数没有用throws进行抛异常,在调用该函数的方法也同样可以捕捉异常。如:
复制代码
 1     public static void function() {  
 2             String s = "abc";  
 3             System.out.println(Double.parseDouble(s));  
 4         }  
 5           
 6         public static void main(String[] args) {  
 7             try {  
 8                 function();  
 9             } catch (Exception e) {  
10                 System.err.println("非数据类型不能转换。");  
11                 //e.printStackTrace();  
12             }  
13     }  
复制代码
  处理结果如下:
 
非数据类型不能转换。
 
说明:某个函数或某段程序块不管会不会,有没可能抛出异常,都可以加try{...}catch{...}去捕捉它
自定义异常
用户可以自定义异常,新建一个异常类,让其继承Exception类或Exception的某个子类。然后用throw抛出自己定义的异常类对象。
在进行程序开发的过程中,自定义异常遵循以下四个步骤:
  1)首先创建自定义异常类,语法格式:自定义异常类名 extends Exception。
 
  2)在方法中通过关键字throw抛出异常对象。
 
  3)若是在当前抛出异常的方法中处理异常,可以用try-catch语句捕获并处理;若不是,在方法的声明处通过关键字throws指明要抛出给方法调用的异常。
 
4)在出现异常方法的调用中捕获并处理异常
如:
复制代码
 1 package packageone;
 2 
 3 //自定义异常类
 4 class MyException extends Exception{
 5     public MyException(String s){
 6         super(s);
 7     }
 8 }
 9 
10 /*
11  * 设计类Number,类中有除法计算方法。使用自定义异常类
12  */
13 class Number{
14     public int divition(int num1,int num2) throws MyException {
15         if (0==num2) {
16             throw new MyException("分母不能为零!");
17         }
18         return (num1/num2);
19     }
20 }
21 //测试自定义异常类
22 public class ExceptionTest{
23     public static void main(String[] args) {
24         Number n = new Number();
25         try {
26             System.out.println("自定义两个数的商的结果为:"+n.divition(12, 0));
27         } catch (MyException e) {
28             System.out.println(e.getMessage());
29             e.printStackTrace();
30         }
31     }
32 }
复制代码
 
 
  处理结果如下:
 
分母不能为零!
packageone.MyException: 分母不能为零!
at packageone.Number.divition(ExceptionTest.java:16)
at packageone.ExceptionTest.main(ExceptionTest.java:26)